Loading...
Searching...
No Matches
ON_RevSurface Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_revsurface.h>`

Inheritance diagram for ON_RevSurface:

## Public Member Functions

void | DestroyRuntimeCache (bool bDelete=true)
| ON_RevSurface ()
| ~ON_RevSurface ()
| ON_RevSurface (const ON_RevSurface &)
ON_RevSurface & | operator= (const ON_RevSurface &)
void | Destroy ()
ON_BOOL32 | SetAngleRadians (double start_angle_radians, double end_angle_radians)
ON_BOOL32 | SetAngleDegrees (double start_angle_degrees, double end_angle_degrees)
unsigned int | SizeOf () const
ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &) const
ON_BOOL32 | Read (ON_BinaryArchive &)
int | Dimension () const
ON_BOOL32 | GetBBox (double *, double *, ON_BOOL32=false) const
void | ClearBoundingBox ()
ON_BOOL32 | Transform (const ON_Xform &)
ON_BOOL32 | SetDomain (int dir, double t0, double t1)
ON_Interval | Domain (int) const
ON_BOOL32 | GetSurfaceSize (double *width, double *height) const
int | SpanCount (int) const
ON_BOOL32 | GetSpanVector (int, double *) const
int | Degree (int) const
ON_BOOL32 | GetParameterTolerance (int, double, double *, double *) const
ON_BOOL32 | IsSpherical (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsCylindrical (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsConical (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsPlanar (ON_Plane *plane=NULL, double tolerance=ON_ZERO_TOLERANCE) const
ON_BOOL32 | IsClosed (int) const
ON_BOOL32 | IsPeriodic (int) const
ON_BOOL32 | IsSingular (int) const
bool | GetNextDiscontinuity (int dir, ON::continuity c, double t0, double t1, double *t, int *hint=NULL, int *dtype=NULL, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
bool | IsContinuous (ON::continuity c, double s, double t, int *hint=NULL, double point_tolerance=ON_ZERO_TOLERANCE, double d1_tolerance=ON_ZERO_TOLERANCE, double d2_tolerance=ON_ZERO_TOLERANCE, double cos_angle_tolerance=ON_DEFAULT_ANGLE_TOLERANCE_COSINE, double curvature_tolerance=ON_SQRT_EPSILON) const
ON_BOOL32 | Reverse (int)
ON_BOOL32 | Transpose ()
ON_BOOL32 | Evaluate (double, double, int, int, double *, int=0, int *=0) const
ON_Curve * | IsoCurve (int dir, double c) const
ON_BOOL32 | Trim (int dir, const ON_Interval &domain)
bool | Extend (int dir, const ON_Interval &domain)
ON_BOOL32 | Split (int dir, double c, ON_Surface *&west_or_south_side, ON_Surface *&east_or_north_side) const
int | GetNurbForm (ON_NurbsSurface &, double=0.0) const
int | HasNurbForm () const
bool | GetSurfaceParameterFromNurbFormParameter (double nurbs_s, double nurbs_t, double *surface_s, double *surface_t) const
bool | GetNurbFormParameterFromSurfaceParameter (double surface_s, double surface_t, double *nurbs_s, double *nurbs_t) const
Public Member Functions inherited from ON_Surface
void | DestroyRuntimeCache (bool bDelete=true)
| ON_Surface ()
| ON_Surface (const ON_Surface &)
ON_Surface & | operator= (const ON_Surface &)
virtual | ~ON_Surface ()
unsigned int | SizeOf () const
bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
virtual ON_Surface * | DuplicateSurface () const
ON::object_type | ObjectType () const
ON_BOOL32 | HasBrepForm () const
ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
ON_BOOL32 | GetDomain (int dir, double *t0, double *t1) const
bool | SetDomain (int dir, ON_Interval domain)
virtual ON_BOOL32 | GetSpanVectorIndex (int dir, double t, int side, int *span_vector_index, ON_Interval *span_interval) const
virtual ISO | IsIsoparametric (const ON_Curve &curve, const ON_Interval *curve_domain=NULL) const
virtual ISO | IsIsoparametric (const ON_BoundingBox &bbox) const
bool | IsSphere (ON_Sphere *sphere=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCylinder (ON_Cylinder *cylinder=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsCone (ON_Cone *cone=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsTorus (ON_Torus *torus=NULL, double tolerance=ON_ZERO_TOLERANCE) const
bool | IsSolid () const
bool | IsAtSingularity (double s, double t, bool bExact=true) const
int | IsAtSeam (double s, double t) const
ON_3dPoint | PointAt (double, double) const
ON_3dVector | NormalAt (double, double) const
ON_BOOL32 | FrameAt (double u, double v, ON_Plane &frame) const
ON_BOOL32 | EvPoint (double u, double v, ON_3dPoint &point, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev1Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, int quadrant=0, int *hint=0) const
ON_BOOL32 | Ev2Der (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &duu, ON_3dVector &duv, ON_3dVector &dvv, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dVector &normal, int quadrant=0, int *hint=0) const
ON_BOOL32 | EvNormal (double u, double v, ON_3dPoint &point, ON_3dVector &du, ON_3dVector &dv, ON_3dVector &normal, int=0, int *=0) const
ON_NurbsSurface * | NurbsSurface (ON_NurbsSurface *pNurbsSurface=NULL, double tolerance=0.0, const ON_Interval *s_subdomain=NULL, const ON_Interval *t_subdomain=NULL) const
void | DestroySurfaceTree ()
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_COMPONENT_INDEX | ComponentIndex () const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON_UUID | ModelObjectId () const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)

## Static Public Member Functions

static ON_RevSurface * | New ()
static ON_RevSurface * | New (const ON_RevSurface &rev_surface)

## Public Attributes

ON_Curve * | m_curve
ON_Line | m_axis
ON_Interval | m_angle
ON_Interval | m_t
ON_BOOL32 | m_bTransposed
ON_BoundingBox | m_bbox

## Additional Inherited Members

Public Types inherited from ON_Surface
enum | ISO { not_iso = 0 , x_iso = 1 , y_iso = 2 , W_iso = 3 , S_iso = 4 , E_iso = 5 , N_iso = 6 , iso_count = 7 }

## Detailed Description

Definition at line 21 of file opennurbs_revsurface.h.

## Constructor & Destructor Documentation

## ON_RevSurface() [1/2]

ON_RevSurface::ON_RevSurface | ( |  | ) |

## ~ON_RevSurface()

ON_RevSurface::~ON_RevSurface | ( |  | ) |

## ON_RevSurface() [2/2]

ON_RevSurface::ON_RevSurface | ( | const ON_RevSurface & |  | ) |

## Member Function Documentation

## ClearBoundingBox()

void ON_RevSurface::ClearBoundingBox | ( |  | ) |

virtual

Reimplemented from ON_Geometry.

## DataCRC()

ON__UINT32 ON_RevSurface::DataCRC | ( | ON__UINT32 | current_remainder | ) | const

virtual

Reimplemented from ON_Object.

## Degree()

int ON_RevSurface::Degree | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Destroy()

void ON_RevSurface::Destroy | ( |  | ) |

## DestroyRuntimeCache()

void ON_RevSurface::DestroyRuntimeCache | ( | bool | bDelete = `true` | ) |

virtual

Reimplemented from ON_Object.

## Dimension()

int ON_RevSurface::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Domain()

ON_Interval ON_RevSurface::Domain | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Dump()

void ON_RevSurface::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## Evaluate()

ON_BOOL32 ON_RevSurface::Evaluate | ( | double | ,
|  | double | ,
|  | int | ,
|  | int | ,
|  | double * | ,
|  | int | = `0`,
|  | int * | = `0`
| ) |  | const

virtual

Implements ON_Surface.

## Extend()

bool ON_RevSurface::Extend | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

## GetBBox()

ON_BOOL32 ON_RevSurface::GetBBox | ( | double * | ,
|  | double * | ,
|  | ON_BOOL32 | = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## GetNextDiscontinuity()

bool ON_RevSurface::GetNextDiscontinuity | ( | int | dir,
|  | ON::continuity | c,
|  | double | t0,
|  | double | t1,
|  | double * | t,
|  | int * | hint = `NULL`,
|  | int * | dtype = `NULL`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetNurbForm()

int ON_RevSurface::GetNurbForm | ( | ON_NurbsSurface & | ,
|  | double | = `0.0`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetNurbFormParameterFromSurfaceParameter()

bool ON_RevSurface::GetNurbFormParameterFromSurfaceParameter | ( | double | surface_s,
|  | double | surface_t,
|  | double * | nurbs_s,
|  | double * | nurbs_t
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetParameterTolerance()

ON_BOOL32 ON_RevSurface::GetParameterTolerance | ( | int | ,
|  | double | ,
|  | double * | ,
|  | double * |
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetSpanVector()

ON_BOOL32 ON_RevSurface::GetSpanVector | ( | int | ,
|  | double * |
| ) |  | const

virtual

Implements ON_Surface.

## GetSurfaceParameterFromNurbFormParameter()

bool ON_RevSurface::GetSurfaceParameterFromNurbFormParameter | ( | double | nurbs_s,
|  | double | nurbs_t,
|  | double * | surface_s,
|  | double * | surface_t
| ) |  | const

virtual

Reimplemented from ON_Surface.

## GetSurfaceSize()

ON_BOOL32 ON_RevSurface::GetSurfaceSize | ( | double * | width,
|  | double * | height
| ) |  | const

virtual

Reimplemented from ON_Surface.

## HasNurbForm()

int ON_RevSurface::HasNurbForm | ( |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsClosed()

ON_BOOL32 ON_RevSurface::IsClosed | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsConical()

ON_BOOL32 ON_RevSurface::IsConical | ( | ON_Cone * | cone = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

## IsContinuous()

bool ON_RevSurface::IsContinuous | ( | ON::continuity | c,
|  | double | s,
|  | double | t,
|  | int * | hint = `NULL`,
|  | double | point_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d1_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | d2_tolerance = `ON_ZERO_TOLERANCE`,
|  | double | cos_angle_tolerance = `ON_DEFAULT_ANGLE_TOLERANCE_COSINE`,
|  | double | curvature_tolerance = `ON_SQRT_EPSILON`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsCylindrical()

ON_BOOL32 ON_RevSurface::IsCylindrical | ( | ON_Cylinder * | cylinder = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

## IsoCurve()

ON_Curve * ON_RevSurface::IsoCurve | ( | int | dir,
|  | double | c
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsPeriodic()

ON_BOOL32 ON_RevSurface::IsPeriodic | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsPlanar()

ON_BOOL32 ON_RevSurface::IsPlanar | ( | ON_Plane * | plane = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

virtual

Reimplemented from ON_Surface.

## IsSingular()

ON_BOOL32 ON_RevSurface::IsSingular | ( | int |  | ) | const

virtual

Reimplemented from ON_Surface.

## IsSpherical()

ON_BOOL32 ON_RevSurface::IsSpherical | ( | ON_Sphere * | sphere = `NULL`,
|  | double | tolerance = `ON_ZERO_TOLERANCE`
| ) |  | const

## IsValid()

ON_BOOL32 ON_RevSurface::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## New() [1/2]

static ON_RevSurface * ON_RevSurface::New | ( |  | ) |

static

## New() [2/2]

static ON_RevSurface * ON_RevSurface::New | ( | const ON_RevSurface & | rev_surface | ) |

static

## operator=()

ON_RevSurface & ON_RevSurface::operator= | ( | const ON_RevSurface & |  | ) |

## Read()

ON_BOOL32 ON_RevSurface::Read | ( | ON_BinaryArchive & |  | ) |

virtual

Reimplemented from ON_Object.

## Reverse()

ON_BOOL32 ON_RevSurface::Reverse | ( | int |  | ) |

virtual

Implements ON_Surface.

## SetAngleDegrees()

ON_BOOL32 ON_RevSurface::SetAngleDegrees | ( | double | start_angle_degrees,
|  | double | end_angle_degrees
| ) |  |

## SetAngleRadians()

ON_BOOL32 ON_RevSurface::SetAngleRadians | ( | double | start_angle_radians,
|  | double | end_angle_radians
| ) |  |

## SetDomain()

ON_BOOL32 ON_RevSurface::SetDomain | ( | int | dir,
|  | double | t0,
|  | double | t1
| ) |  |

virtual

Reimplemented from ON_Surface.

## SizeOf()

unsigned int ON_RevSurface::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SpanCount()

int ON_RevSurface::SpanCount | ( | int |  | ) | const

virtual

Implements ON_Surface.

## Split()

ON_BOOL32 ON_RevSurface::Split | ( | int | dir,
|  | double | c,
|  | ON_Surface *& | west_or_south_side,
|  | ON_Surface *& | east_or_north_side
| ) |  | const

virtual

Reimplemented from ON_Surface.

## Transform()

ON_BOOL32 ON_RevSurface::Transform | ( | const ON_Xform & |  | ) |

virtual

Reimplemented from ON_Geometry.

## Transpose()

ON_BOOL32 ON_RevSurface::Transpose | ( |  | ) |

virtual

Implements ON_Surface.

## Trim()

ON_BOOL32 ON_RevSurface::Trim | ( | int | dir,
|  | const ON_Interval & | domain
| ) |  |

virtual

Reimplemented from ON_Surface.

## Write()

ON_BOOL32 ON_RevSurface::Write | ( | ON_BinaryArchive & |  | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_angle

ON_Interval ON_RevSurface::m_angle

Definition at line 40 of file opennurbs_revsurface.h.

## m_axis

ON_Line ON_RevSurface::m_axis

Definition at line 35 of file opennurbs_revsurface.h.

## m_bbox

ON_BoundingBox ON_RevSurface::m_bbox

Definition at line 59 of file opennurbs_revsurface.h.

## m_bTransposed

ON_BOOL32 ON_RevSurface::m_bTransposed

Definition at line 56 of file opennurbs_revsurface.h.

## m_curve

ON_Curve* ON_RevSurface::m_curve

Definition at line 32 of file opennurbs_revsurface.h.

## m_t

ON_Interval ON_RevSurface::m_t

Definition at line 50 of file opennurbs_revsurface.h.

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_revsurface.h